/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                   Java -- bohatstv knihoven                //
//                II. opraven a rozen vydn              //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       Cti_me.txt                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2006                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.util.*;

class Osoba {
  // zakladni stavove atributy
  protected boolean muz;
  protected int vyska;
  protected double vaha;
  protected String jmeno;
  // bitovy obraz vahy pro hashCode() a equals()
  // odvozeny atribut
  protected long longVaha;
  private static Random r = new Random(1234);

  Osoba() {
    this.muz = r.nextBoolean();
    // vyska <170; 200>
    this.vyska = 170 + r.nextInt(31);
    // vaha <50; 100)
    this.vaha = 50 + 50 * r.nextDouble();
    this.longVaha = Double.doubleToLongBits(this.vaha);
    byte[] b = new byte[5];
    for (int i = 0;  i < 5;  i++)
      b[i] = (byte) ((r.nextInt(26) + (byte) 'a'));
    jmeno = new String(b);
  }

  public String toString() {
    return jmeno + ", " + (muz ? "muz " : "zena") + ", " + vyska + ", " + vaha;
  }

  public boolean equals(Object o) {
    if (o == this)
      return true;
    if (o instanceof Osoba == false)
      return false;
    Osoba os = (Osoba) o;
    boolean bMuz = this.muz == os.muz;
    boolean bVyska = this.vyska == os.vyska;
    boolean bVaha = this.longVaha == os.longVaha;
    boolean bJmeno = this.jmeno.equals(os.jmeno);
    return bMuz && bVyska && bVaha && bJmeno;
  }
}

class NevhodnaOsoba extends Osoba {
  public int hashCode() {
    return vyska;
  }
}

class PrijatelnaOsoba extends Osoba {
  public int hashCode() {
    return (int) (vyska * vaha);
  }
}

class PerfektniOsoba extends Osoba {
  public int hashCode() {
    int vysledek = 17;
    int pom;
    pom = this.muz ? 0 : 1;
    vysledek = 37 * vysledek + pom;
    pom = this.vyska;
    vysledek = 37 * vysledek + pom;
    long l = Double.doubleToLongBits(this.vaha);
    pom = (int) (l ^ (l >>> 32));
    vysledek = 37 * vysledek + pom;
    pom = this.jmeno.hashCode();
    vysledek = 37 * vysledek + pom;
    return vysledek;
  }
}

class NemennaPerfektniOsoba extends PerfektniOsoba {
  protected int hashKod;
  NemennaPerfektniOsoba() {
     super();
     hashKod = super.hashCode();
  }

  public int hashCode() {
    return hashKod;
  }
}

public class RozlozeniHashCode {
  static int pocet = 100000;

  public static void main(String[] args) {
    if (args.length > 0) {
      pocet = Integer.parseInt(args[0]);
    }

    ArrayList<Integer> pole = new ArrayList<Integer>(pocet);
    Osoba o;
    for (int i = 0;  i < pocet;  i++) {
//      o = new NevhodnaOsoba();
      o = new PrijatelnaOsoba();
//      o = new PerfektniOsoba();
      pole.add(new Integer(o.hashCode()));
    }
    Set<Integer> rozdilne = new HashSet<Integer>(pole);
    System.out.println("Rozdilnych: " + rozdilne.size());

    int shodnych = pocet - rozdilne.size();
    System.out.println("Shodnych:   " + shodnych);
    if (shodnych < 100) {
      Collections.sort(pole);
      for (int i = 0;  i < pocet - 1;  i++) {
        if (pole.get(i).equals(pole.get(i + 1)) == true)
          System.out.print(pole.get(i) + ", ");
      }
    }
  }
}
